
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libsmbclient.h>
#include <errno.h>
#include <regex.h>
#include <pthread.h>
#include <unistd.h>
#include <ctype.h>
#include "bsd_sys_queue.h"
#include "samba.h"

struct samba_state samba;

/*
char **listcat(char **dest, int *destsize, const char **src, int *size) {
  int i=0,j=0,k;
  while (strncmp(src[i],"smb",3)==0) {
    while(strncmp(dest[j],"smb",3)==0) {
      printf("dest[%d] : %s\n",j,dest[j]);
      j++;
      printf("truc\n");
    }
    printf("%d\n",*destsize);
    //if ((j%20) == 0) {
    if (j==((*destsize))) {  
      //printf("Malloc\n");
      dest = (char**)realloc(dest,(j+20) * sizeof(char*));
      for (k=0;k<20;k++) {
        dest[j+k] = (char*)Malloc(256 * sizeof(char));
      }
    }
    printf("i: %d j: %d src: %s dest: %s\n",i,j,src[i],dest[j]);
    strcpy(dest[j],src[i]);
    i++;
    j++;
  }
  *size=j;
  return dest;
}
*/

static void auth(const char *server, const char *share,
  	     char *workgroup, int wgmaxlen, char *username, int unmaxlen,
  	     char *password, int pwmaxlen)
{
	return;
}



int init_samba( void )
{
  int err;

  printf("Samba: initialize Samba network components\n");

  STAILQ_INIT( &samba.smb_network );
  pthread_mutex_init( &samba.smb_thread_mutex, NULL );
  pthread_mutex_init( &samba.smb_network_mutex, NULL );
  
  if ( samba.smb_error_lvl >= 3 )
    err = smbc_init( auth, 1 );
  else
    err = smbc_init( auth, 0 );

  if ( err < 0 ) {
    printf("%s: Unable to create a samba client", PROG_NAME);
    perror("");
    return err;
  }
  
  printf("Samba initialized\n");
  return 0;
}

int close_samba( void )
{
  pthread_mutex_destroy( &samba.smb_thread_mutex );
  pthread_mutex_destroy( &samba.smb_network_mutex );

  return 0;
}


int browse_fileshare(struct fileshare* share) {
  struct computer* computer = share->share_computer;
  struct smbc_dirent *dir;
  char url[URL_SIZE];
  size_t url_len;/*length of share_url*/
  size_t url_len2; /*length of url*/
  int fd = 0;

  snprintf(url, sizeof(url), "smb://%s/%s", computer->computer_netbiosname, share->share_url);
  url_len = strlen( share->share_url );
  url_len2 = strlen( url );
  
  fd = smbc_opendir(url);
  if (fd < 0) {
    printf( "Samba: Erreur browse_fileshare->smbc_opendir %s: %s\n", url, strerror(errno) );
    return -1;
  }

  while ((dir = smbc_readdir(fd))) {
    if (dir->smbc_type == SMBC_FILE) {
      struct fileshare * file = NULL;
      char * file_url = NULL;
      size_t len = 0;

      /* build url name */
      len = url_len2 + strlen(dir->name) + 2;	/* +2 because of : '/' and '\0'  */
      file_url = (char*)Malloc( len );
      snprintf( file_url, len, "%s/%s", url, dir->name );
	  	  
	  /* alloc new file : */
      file = fileshare_alloc( computer, SMBC_FILE, strdup( dir->name ), file_url );
	  
      /* insert new file */
      STAILQ_INSERT_TAIL(&share->share_list, file, share_next);
      share->share_size ++;


      pthread_mutex_lock( &samba.smb_thread_mutex );
      samba.smb_files++;
      pthread_mutex_unlock( &samba.smb_thread_mutex );
    }
    else if (dir->smbc_type == SMBC_DIR) {
      struct fileshare * sharedir = NULL;
      char * dir_url = NULL;
      size_t len = 0;

      if ((strcmp(dir->name, ".") == 0) || (strcmp(dir->name, "..") == 0))
        continue;

      /* build url name */
      len = url_len + strlen(dir->name) + 2;	/* +2 because of : '/' and '\0'  */
      dir_url = (char*)Malloc( len ); 
      snprintf( dir_url, len, "%s/%s", share->share_url, dir->name );
	        
      /* alloc new dir : */
      sharedir = fileshare_alloc( computer, SMBC_DIR, strdup( dir->name ), dir_url );
	  //printf("share_url : smb://%s/%s\n",sharedir->share_computer->computer_netbiosname,sharedir->share_url);
	  
      /* insert new dir */
      STAILQ_INSERT_TAIL(&share->share_list, sharedir, share_next);
      share->share_size ++;

      /* continue browsing in sub dirs */
      browse_fileshare(sharedir);

      pthread_mutex_lock( &samba.smb_thread_mutex );
      samba.smb_dirs++;
      pthread_mutex_unlock( &samba.smb_thread_mutex );
    }
  }

  smbc_closedir(fd);

  return 0;
}

/*int readSmbConf() {
  FILE *fp;
  int end;
  char txt[500];
  if ((fp = fopen("/usr/local/samba/lib/smb.conf","r")) != NULL) {
  }
  else if ((fp = fopen("/etc/samba/smb.conf","r")) != NULL) {
  }
  else if ((fp = fopen("/usr/local/samba/smb.conf","r")) != NULL) {
  }
  else if ((fp = fopen("/usr/local/samba/etc/smb.conf","r")) != NULL) {
  }
  else if ((fp = fopen("/etc/smb.conf","r")) != NULL) {
  }
  else {
    printf("File smb.conf not found.\n");
    strcpy(default_samba_workgroup,"UNKNOWN");
    strcpy(default_samba_wins_server, "none");
    return -1;
  }
  while (end != 1) {
    fscanf(fp,"%s",&txt);
    if (strcmp(txt,"workgroup") == 0) {
      fscanf(fp,"%s",&txt);
      fscanf(fp,"%s",&default_samba_workgroup);
      printf("workgroup : %s\n",default_samba_workgroup);
      end = 1;
    }
  }
  return 0;
  }*/


#warning search disactivated
          
#if 0
void search_file_in_dir(smbcfile *file, const char *title, smbcfile ***result, int *size) { 
  char *str2, *strfile;

  strfile = (char*)Malloc(strlen(file->file_name) * sizeof(char));

  /*
  for (str = title; *str; *str = tolower (*str++));
  for (str = file->file_name, dst = strfile; *str; *dst++ = tolower (*str++));
  */

  /* should use regex !!! */
/*  str2 = strstr(strfile,title); */


  if ((file->file_smbctype == SMBC_FILE) ) {
    /* trouve a implementer mettre ds une liste */
    if (*size == 0) {
      *result = (smbcfile**)Malloc(20 * sizeof(smbcfile*));
      for (i=0;i<20;i++) {
        (*(result))[i] = (smbcfile*)Malloc(sizeof(smbcfile));
        init_file((*(result))[i], 256);
      }
    }
    printf("truc !!!!!! %s %s\n", title, file->file_name);
    if (*size==(0%20) && *size!=0) {
      *result = (smbcfile**)realloc(file->file_list,(*size+20) * sizeof(smbcfile*));
      for (j=0;j<20;j++) {
        *result[*size+j] = (smbcfile*)Malloc(sizeof(smbcfile));
        printf("%d\n",(*size+j));
        printf ("**** PASS 3\n");
        init_file(*result[*size+j], 256);
        printf ("**** PASS 5 %d\n",j);
      }
      printf ("**** PASS 4\n");
    }
    printf ("**** PASS 1 %d\n", *size);
    //(*result)[*size] = file;
    printf ("**** PASS 2\n");
    (*size)++;
    printf("size : %d\n", *size);
  } else if (file->file_smbctype == SMBC_DIR) {
    for (i=0; i < file->file_list_size; i++) {
      search_file_in_dir(file->file_list[i], title, result, size);
    }
  }
}
#endif
